;------------------------------------------------------------------------------
;HEADER.ASM: CODE SAMPLE FOR LAUNCHING A C PROGRAM IN 32 BIT TINY MODEL (BC4)
;..............................................................................
;
;compile C module using something like:
;"bcc32 -c -4 -O2 -zAcode -zBcode -zTcode -zD_text -zR_text hello.c"
;This will make _text a part of DGROUP thus beeing flatter than flat
;
;use old style tlink, create MZ- .EXE:
;"tlink /3 header.obj+helloobj"
;
;put extender stub in front of the thing
;"copy /b wdosx.dx+header.exe hello.exe"
;
;------------------------------------------------------------------------------

.386p

;------------------------------------------------------------------------------
;	Segment declaration, everything is just in _TEXT
;------------------------------------------------------------------------------

_TEXT		segment byte public use32 'CODE'
_TEXT		ends

		extrn	_main:near
		public	_printf

		assume	cs:_TEXT,ds:_TEXT
_TEXT		segment byte public use32 'CODE'

;------------------------------------------------------------------------------
;	Stupid first try for "printf"
;	This one ignores all but direct character output
;	just to get the "printf ("Hello, world!/n") done
;------------------------------------------------------------------------------

_printf		proc	near
		push	ebp
		mov	ebp,esp
		mov	ebx,[ebp+8]	;get formatting string

dosx001:
		mov	dl,[ebx]
		test	dl,dl		;done?
		jz	short dosx002	
		cmp	dl,10		;convert unix style /n
		jnz	short dosx003
		mov	dl,13
		mov	ah,2
		int	21h
		mov	dl,10

dosx003:
		mov	ah,2	
		int	21h
		inc	ebx
		jmp	short dosx001

dosx002:
		pop	ebp
		ret
_printf		endp

;------------------------------------------------------------------------------
;	Global(s)
;------------------------------------------------------------------------------

dosx_segsize	dd	?		;initial segment size
dosx_psp_sel	dw	?		;Selector for PSP (DPMI style)

;------------------------------------------------------------------------------
;	Program entry point is right here (called by DOS extender stub)
;------------------------------------------------------------------------------

start:

;------------------------------------------------------------------------------
;	Store some stuff, nothing needed in the example, but in general:
;	if the C program is allocating memory or parsing command tail,
;	we must save these
;------------------------------------------------------------------------------

		mov	dosx_segsize,esp
		mov	dosx_psp_sel,es

		push	ds
		pop	es

;------------------------------------------------------------------------------
;	If the runtime needed some sort of initialization, it had
;	to be done right here
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
;	Launch a C program (or call a function, that's the same)
;------------------------------------------------------------------------------

		call	_main

;------------------------------------------------------------------------------
;	Terminate DPMI style
;------------------------------------------------------------------------------

		mov	ah,4ch
		int	21h

_TEXT		ends
end		start

